﻿@page
@using System.Globalization
@using System.Net
@using Estat.Sri.Ws.NSIWebServiceCore
@using Estat.Sri.Ws.Wsdl
@using NSIWebServiceCore.Pages
@model IndexModel
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
@{
    string applicationPath = $"{this.Request.Scheme}://{this.Request.Host}{this.Request.PathBase}";

    if (!applicationPath.EndsWith("/"))
    {
        applicationPath = applicationPath + "/";
    }
    Uri requestedUrl = new Uri(applicationPath);

    IPAddress address = null;
    string dnsSafeHost = requestedUrl.DnsSafeHost;

    if (!IPAddress.TryParse(dnsSafeHost, out address))
    {
        IPHostEntry host = Dns.GetHostEntry(dnsSafeHost);
        address = IndexModel.TryGetExternal(host);
    }

    bool isLocal = IPAddress.IsLoopback(address) || requestedUrl.IsLoopback;
    bool isPrivate = !isLocal && IndexModel.IsPrivate(address);
    bool isExternal = !(isLocal || isPrivate);

    string resultClass = isExternal ? "external" : isPrivate ? "private" : "localhost";
    string helpMessage = isExternal ? Messages.help_external : isPrivate ? Messages.help_not_external : Messages.help_localhost;}
<head>
    <link rel="stylesheet" href="~/css/main.css" />
</head>
<body>
    <div id="page-content">
        <div id="page-content-inner">
            <div id="page-header">
                <div id="page-header-left">
                </div>
                <div id="page-header-right">
                </div>
            </div>
            <div id="page-body">
                <div id="pb-workarea-pages">
                    <div id="pb-host">
                        <h1>@Messages.label_request_info</h1>
                        <table class="results-table">
                            <thead>
                                <tr>
                                    <th>@Messages.label_request_property</th>
                                    <th>@Messages.label_request_value</th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <th>@Messages.label_request_root_url</th>
                                    <td>@requestedUrl.ToString()</td>
                                </tr>
                                <tr>
                                    <th>@Messages.label_request_host</th>
                                    <td>@dnsSafeHost</td>
                                </tr>
                                <tr>
                                    <th>@Messages.label_request_port</th>
                                    <td>@requestedUrl.Port</td>
                                </tr>
                                <tr>
                                    <th>@Messages.label_request_is_external</th>
                                    <td class="@resultClass">@isExternal.ToString(CultureInfo.CurrentUICulture)</td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div id="pb-endpoints">
                        <h1>@Messages.label_endpoints_info</h1>
                        <table class="results-table">
                            <thead>
                                <tr>
                                    <th>@Messages.label_endpoint_name</th>
                                    <th>@Messages.label_endpoint_path</th>
                                    <th>@Messages.label_endpoint_namespace</th>
                                    <th>@Messages.label_endpoint_wsdl</th>
                                    <th>@Messages.label_endpoint_xsd</th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach (ServiceInfo webServiceInfo in IndexModel.WebServices)
                                {
                                    string endpointUrl = string.Format(CultureInfo.InvariantCulture, "{0}{1}", requestedUrl, webServiceInfo.Name);
                                    <tr>
                                        <td>@webServiceInfo.Description</td>
                                        <td>@string.Format(CultureInfo.InvariantCulture, "{0}{1}", endpointUrl, webServiceInfo.Enabled ? string.Empty : " (disabled) ")</td>
                                        <td>@webServiceInfo.Namespace</td>
                                        <td><a class="page-links" href="@string.Format(CultureInfo.InvariantCulture, "{0}{1}?wsdl", requestedUrl, webServiceInfo.Name)">@Messages.lable_endpoint_link_wsdl</a></td>
                                        <td><a class="page-links" href="@string.Format(CultureInfo.InvariantCulture, "{0}{1}/SDMXMessage.xsd", requestedUrl, webServiceInfo.SchemaPath)">@Messages.lable_endpoint_link_xsd</a></td>
                                    </tr>
                                }
                            </tbody>
                        </table>
                        <h2>RESTful API</h2>
                        <table class="results-table">
                            <thead>
                                <tr>
                                    <th>Service name</th>
                                    <th>Resource base</th>
                                    <th>Swagger</th>
                                    <th>Specifications</th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>RESTful API</td>
                                    <td>@($"{requestedUrl}rest/")</td>
                                    <td><a href="@($"{requestedUrl}swagger/index.html?urls.primaryName=v1")">@($"{requestedUrl}swagger/index.html?urls.primaryName=v1")</a></td>
                                    <td><a class="page-links" href="@string.Format(CultureInfo.InvariantCulture, "{0}swagger/v1/sdmx-rest.yaml", requestedUrl)">sdmx-rest.yaml</a></td>
                                </tr>
                                <tr>
                                    <td>RESTful API 2.0</td>
                                    <td>@($"{requestedUrl}rest/v2")</td>
                                    <td><a href="@($"{requestedUrl}swagger/index.html?urls.primaryName=v2")">@($"{requestedUrl}swagger/index.html?urls.primaryName=v2")</a></td>
                                    <td><a class="page-links" href="@string.Format(CultureInfo.InvariantCulture, "{0}swagger/v2/sdmx-rest.yaml", requestedUrl)">sdmx-rest.yaml</a></td>
                                </tr>
                            </tbody>
                        </table>
                    </div>

                    <div id="pb-help" class="help-message">
                        <h1>@Messages.label_remarks</h1>
                        <p>
                            @helpMessage
                        </p>
                    </div>
                </div>
            </div>
            <div id="page-footer">
                <div id="page-footer-copyright">
                    @Messages.app_copyright
                </div>
                <div id="page-footer-version">
                    @IndexModel.Version
                </div>
            </div>
        </div>
    </div>
</body>
